const mongoose = require('mongoose');
const config = require('../config/database');

const OfficePackSchema = mongoose.Schema({
  packageName: { type: String, required: true },
  packageAmount: { type: String, required: true },
  distributionCount: { type: String, required: true },
  createdBy: { type: String, required: true },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedBy: { type: String },
  updatedAt: { type: Date, default: Date.now() }
});

const OfficePackage = (module.exports = mongoose.model(
  'officePackage',
  OfficePackSchema
));

module.exports.addPackage = (newPackage, callback) => {
  newPackage.save(callback);
};

module.exports.getPackageById = (id, callback) => {
  OfficePackage.findOne({ _id: id }, callback);
};

module.exports.getPackageByName = (packageName, callback) => {
  OfficePackage.findOne({ packageName: packageName }, callback);
};

module.exports.getAllPackages = function(callback) {
  OfficePackage.find(callback);
};
