const mongoose = require('mongoose');
const config = require('../config/database');

const OldMemberTypeSchema = mongoose.Schema({
  memberType: String,
  createdBy: { type: String, required: true },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date, default: Date.now() },
  updatedBy: { type: String }
});

const OldMemberType = (module.exports = mongoose.model(
  'OldMemberType',
  OldMemberTypeSchema
));

module.exports.addMemberType = (oldMember, callback) => {
  oldMember.save(callback);
};

module.exports.getMemberByType = (memberType, callback) => {
  OldMemberType.findOne({ memberType: memberType }, callback);
};

module.exports.getMember = callback => {
  OldMemberType.find(callback);
};
