const mongoose = require('mongoose');
const config = require('../config/database');

const purposeSchema = mongoose.Schema({
  purposeName: { type: String },
  shortName: { type: String },
  show: { type: String, default: 'Y' },
  purposeCode: { type: String },
  purposeId: { type: String },
  allotedBy: { type: String },
  createdAt: { type: Date, default: Date.now() }
});

const Purpose = (module.exports = mongoose.model('purpose', purposeSchema));

module.exports.addPurpose = (newPurpose, callback) => {
  newPurpose.save(callback);
};

module.exports.getPurposeByPurposecode = (purposecode, callback) => {
  Purpose.findOne({ purposeCode: purposecode }, callback);
};

module.exports.getPurposebyName = (purpose, callback) => {
  Purpose.findOne({ purposeName: purpose }, callback);
};

module.exports.getPurposeById = (id, callback) => {
  Purpose.findOne({ _id: id }, callback);
};

module.exports.getAllPurposes = callback => {
  Purpose.find(callback);
};
