var express = require('express');
var _router = express.Router();
var multer = require('multer');
var path = require('path');
const  multipart  =  require('connect-multiparty');
const  multipartMiddleware  =  multipart({ uploadDir:  './uploads' });

_router.post('/import', multipartMiddleware, (req, res) => {
    res.json({
        'message': 'File uploaded successfully'
    });
});

var store = multer.diskStorage({
    destination:function(req,file,cb){
        // cb(null, './../devmusical/assets');
        // cb(null, './../devmusical/src/assets');
        cb(null, './');
        // cb(null, './../devmusical_universal/dist/browser/assets');
        // cb(null, '/home/devmusical12/public_html/assets');
    },
    filename:function(req,file,cb){
        cb(null, Date.now()+'_'+file.originalname);
    }
});


var upload = multer({storage:store}).single('file');

_router.post('/upload' ,function(req,res,next){
    console.log(req.file);
    upload(req,res,function(err){
        if(err){
            return res.status(501).json({error:err});
        }
        //do all database record saving activity
        return res.json({msg: 'Uploaded Successfully', file: req.file});
        // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
    });
});


_router.post('/download', function(req,res,next){
    filepath = path.join(__dirname,'/devmusical/assets') +'/'+ req.body.filename;
    res.sendFile(filepath);
});



module.exports = _router;
