const express = require('express');
const router = express.Router();
const passport = require('passport');
const OfficePackage = require('../models/office-package');

// create office pacakge
router.post(
  '/create-office-package',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    OfficePackage.getPackageByName(req.body.packageName, (err, package) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'error occured',
          err: JSON.stringify(err)
        });
      } else {
        if (package) {
          res.status(200).json({
            success: true,
            msg: 'package name already exist',
            package: package
          });
        } else {
          let officePack = new OfficePackage({
            packageName: req.body.packageName,
            packageAmount: req.body.packageAmount,
            distributionCount: req.body.distributionCount,
            createdBy: req.body.createdBy
          });
          OfficePackage.addPackage(officePack, (err, pack) => {
            if (err) {
              res.status(200).json({
                success: false,
                msg: 'error occured',
                err: JSON.stringify(err)
              });
            } else {
              res.status(200).json({
                success: true,
                msg: 'package created successfully',
                package: pack
              });
            }
          });
        }
      }
    });
  }
);

// get all office-packages
router.get(
  '/get-office-packages',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    OfficePackage.getAllPackages((err, packs) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'error occured',
          err: JSON.stringify(err)
        });
      } else {
        res
          .status(200)
          .json({
            success: true,
            msg: 'office packages found',
            packages: packs
          });
      }
    });
  }
);

module.exports = router;
