const express = require('express');
const router = express.Router();
const config = require('../config/database');
const Purpose = require('../models/purpose');
const passport = require('passport');

router.post(
  '/create-purpose',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let purpose = new Purpose({
      createdBy: req.body.createdBy,
      purposeName: req.body.purposeName,
      shortName: req.body.shortName,
      show: req.body.show
    });

    Purpose.addPurpose(purpose, (err, newPurpose) => {
      if (err) {
        res.status(200).json({ success: false, msg: '', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Purpose added successfully',
          purpose: newPurpose
        });
      }
    });
  }
);

router.get(
  '/getAllPurpose',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Purpose.getAllPurposes((err, purposeList) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch purpose list.',
          err: err
        });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Purpose list fetched',
          purposeList: purposeList
        });
      }
    });
  }
);

router.post(
  '/getPurposeById',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Purpose.getPurposeById(req.body.purposeId, (err, purpose) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch purpose details',
          err: err
        });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'purpose fetched', purpose: purpose });
      }
    });
  }
);

module.exports = router;
