const express = require('express');
const router = express.Router();
const config = require('../config/database');
const Source = require('../models/source');
const passport = require('passport');

router.post(
  '/create-source',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let source = new Source({
      createdBy: req.body.createdBy,
      sourceName: req.body.sourceName,
      shortName: req.body.shortName,
      show: req.body.show
    });

    Source.addSource(source, (err, newSource) => {
      if (err) {
        res.status(200).json({ success: false, msg: '', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Source added successfully',
          source: newSource
        });
      }
    });
  }
);

router.get(
  '/getAllSource',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Source.getAllSources((err, sourceList) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch source list.',
          err: err
        });
      } else {
        res.status(200).json({
          success: true,
          msg: 'Source list fetched',
          sourceList: sourceList
        });
      }
    });
  }
);

router.post(
  '/getSourceById',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Source.getSourceById(req.body.sourceId, (err, source) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch source details',
          err: err
        });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'source fetched', source: source });
      }
    });
  }
);

module.exports = router;
