const express = require('express');
const router = express.Router();
const State = require('../models/state');
const passport = require('passport');
const User = require('../models/user');
const _ = require('lodash');

router.get(
  '/get-states',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    State.getAllStates((err, states) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Something went wrong', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'states are found', states: states });
      }
    });
  }
);

router.get(
  '/get-citiesof/:state',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    State.getStatebyName(req.params.state, (err, state) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Error in fetching state cities',
          err: err
        });
      } else {
        res.status(200).json({
          success: true,
          msg: 'state cities are found',
          cities: state.cities
        });
      }
    });
  }
);

module.exports = router;
