const express = require('express');
const mongoose = require('mongoose');
const cors = require('cors');
const bodyParser = require('body-parser');
const config = require('./config/database');
const passport = require('passport');
var path = require('path');
var favicon = require('serve-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');


mongoose.connect(config.database, {
  useNewUrlParser: true,
  autoIndex: false
});

mongoose.connection.on('connected', () => {
  console.log('connected to db ' + config.database);
});

mongoose.connection.on('error', err => {
  console.log('database error:' + err);
});

const app = express();
app.use(cors());

// passport
app.use(passport.initialize());
app.use(passport.session());
require('./config/passport')(passport);
// passport end


// parse application/x-www-form-urlencoded
// Body Parser Middleware
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));

const newLead = require('./routes/leads');
const file = require('./routes/file');
app.use('/leads', newLead);
app.use('/file', file);

// app.use(
  //   bodyParser.urlencoded({
    //     extended: true
    //   })
    // );
    // app.use(bodyParser.json({ limit: '50mb' }));
    // app.use(bodyParser.urlencoded({ limit: '50mb', extended: true }));
    // app.use(bodyParser.json());
    
    app.get('/', (req, res) => {
      res.send('Root Ankur');
    });
    
    const user = require('./routes/users');
    const office = require('./routes/offices');
    const member = require('./routes/members');
    const memberType = require('./routes/member-types');
    const followUpType = require('./routes/followUpTypes');
    const officePackage = require('./routes/office-packages');
    const remainder = require('./routes/remainders');
    const cities = require('./routes/cities');
    const states = require('./routes/states');
    const request = require('./routes/requests');
    const approvedRequest = require('./routes/approvedRequests');
    const leadpackage = require('./routes/leadpackages');
    const purposes = require('./routes/purposes');
    const sources = require('./routes/sources');
    const upload = require('./routes/upload-img-index');
    const lead = require('./routes/leads');
    
    
app.use('/approvedrequests', approvedRequest);
app.use('/requests', request);
app.use('/remainders', remainder);
app.use('/officepackages', officePackage);
app.use('/followuptypes', followUpType);
app.use('/membertypes', memberType);
app.use('/packages', leadpackage);
app.use('/members', member);
app.use('/office', office);
app.use('/cities', cities);
app.use('/states', states);
app.use('/user', user);
app.use('/purposes', purposes);
app.use('/sources', sources);
app.use('/upload', upload);
app.use('/lead', lead);

// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

// // catch 404 and forward to error handler
// app.use(function(req, res, next) {
//   var err = new Error('Not Found');
//   err.status = 404;
//   next(err);
// });

// // error handler
// app.use(function(err, req, res, next) {
//   // set locals, only providing error in development
//   res.locals.message = err.message;
//   res.locals.error = req.app.get('env') === 'development' ? err : {};

//   // render the error page
//   res.status(err.status || 500);
//   res.render('error');
// });

port = 3300;
host = '0.0.0.0';

app.listen(port, host, () => {
  console.log('Server is running in port: ' + port);
});

